// $Id: nice_menus.js,v 1.1.4.1 2006/08/11 12:48:17 jakeg Exp $

// We only do the javascript in IE.
// TODO: because we now only include the js file for IE, is this 'if' redundant?
if (document.all) {

  // We borrow some functions from Drupal 4.7 /misc/drupal.js

  /**
   * Returns true if an element has a specified class name
   */
  function hasClass(node, className) {
    if (node.className == className) {
      return true;
    }
    var reg = new RegExp('(^| )'+ className +'($| )')
    if (reg.test(node.className)) {
      return true;
    }
    return false;
  }

  /**
   * Adds a class name to an element
   */
  function addClass(node, className) {
    if (hasClass(node, className)) {
      return false;
    }
    node.className += ' '+ className;
    return true;
  }

  /**
   * Removes a class name from an element
   */
  function removeClass(node, className) {
    if (!hasClass(node, className)) {
      return false;
    }
    // Replaces words surrounded with whitespace or at a string border with a space. Prevents multiple class names from being glued together.
    node.className = eregReplace('(^|\\s+)'+ className +'($|\\s+)', ' ', node.className);
    return true;
  }

  /**
   * Emulate PHP's ereg_replace function in javascript
   */
  function eregReplace(search, replace, subject) {
    return subject.replace(new RegExp(search,'g'), replace);
  }

  // now our functions
  function IEHoverPseudo() {

    var ulNodes = getElementsByClass("nice-menu");
    var j = 0;
    var liNodes = null;

    for (var i = 0; i < ulNodes.length; i++) { 
      liNodes = ulNodes[i].getElementsByTagName("li");
      for (j = 0; j < liNodes.length; j++) {
        if (hasClass(liNodes[j], 'menuparent')) {
          liNodes[j].onmouseover=function() { addClass(this, 'over'); }
          liNodes[j].onmouseout=function() { removeClass(this, 'over'); }
        }
      }
    }
  }

  function getElementsByClass(searchClass,node,tag) {
	  var classElements = new Array();
	  if (node == null) node = document;
	  if (tag == null) tag = '*';
	  var els = node.getElementsByTagName(tag);
	  var elsLen = els.length;
	  var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
	  for (i = 0, j = 0; i < elsLen; i++) {
		  if (pattern.test(els[i].className)) {
			  classElements[j] = els[i];
			  j++;
		  }
	  }
	  return classElements;
  }

  window.onload = IEHoverPseudo;
}